# wxUpdateUIEvent Class Reference
[Events]

`#include <wx/event.h>`

Inheritance diagram for wxUpdateUIEvent:
[legend]

## Detailed Description

This class is used for pseudo-events which are called by wxWidgets to give an application the chance to update various user interface elements.

Without update UI events, an application has to work hard to check/uncheck, enable/disable, show/hide, and set the text for elements such as menu items and toolbar buttons. The code for doing this has to be mixed up with the code that is invoked when an action is invoked for a menu item or button.

With update UI events, you define an event handler to look at the state of the application and change UI elements accordingly. wxWidgets will call your member functions in idle time, so you don't have to worry where to call this code.

In addition to being a clearer and more declarative method, it also means you don't have to worry whether you're updating a toolbar or menubar identifier. The same handler can update a menu item and toolbar button, if the identifier is the same. Instead of directly manipulating the menu or button, you call functions in the event object, such as wxUpdateUIEvent::Check. wxWidgets will determine whether such a call has been made, and which UI element to update.

These events will work for popup menus as well as menubars. Just before a menu is popped up, wxMenu::UpdateUI is called to process any UI events for the window that owns the menu.

If you find that the overhead of UI update processing is affecting your application, you can do one or both of the following:

- Call wxUpdateUIEvent::SetMode with a value of wxUPDATE_UI_PROCESS_SPECIFIED, and set the extra style wxWS_EX_PROCESS_UI_UPDATES for every window that should receive update events. No other windows will receive update events.
- Call wxUpdateUIEvent::SetUpdateInterval with a millisecond value to set the delay between updates. You may need to call wxWindow::UpdateWindowUI at critical points, for example when a dialog is about to be shown, in case the user sees a slight delay before windows are updated.

Note that although events are sent in idle time, defining a wxIdleEvent handler for a window does not affect this because the events are sent from wxWindow::OnInternalIdle which is always called in idle time.

wxWidgets tries to optimize update events on some platforms. On Windows and GTK+, events for menubar items are only sent when the menu is about to be shown, and not in idle time.

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxUpdateUIEvent& event)
Event macros:

- EVT_UPDATE_UI(id, func):
  Process a `wxEVT_UPDATE_UI` event for the command with the given id.
- EVT_UPDATE_UI_RANGE(id1, id2, func):
  Process a `wxEVT_UPDATE_UI` event for any command with id included in the given range.

##

Library: wxCore

Category: Events

See also:
  Events and Event Handling

## Public Member Functions
| wxUpdateUIEvent (wxWindowID commandId=0)
| Constructor.
void | Check (bool check)
| Check or uncheck the UI element.
void | Enable (bool enable)
| Enable or disable the UI element.
bool | GetChecked () const
| Returns true if the UI element should be checked.
bool | GetEnabled () const
| Returns true if the UI element should be enabled.
bool | GetSetChecked () const
| Returns true if the application has called Check().
bool | GetSetEnabled () const
| Returns true if the application has called Enable().
bool | GetSetShown () const
| Returns true if the application has called Show().
bool | GetSetText () const
| Returns true if the application has called SetText().
bool | GetShown () const
| Returns true if the UI element should be shown.
wxString | GetText () const
| Returns the text that should be set for the UI element.
void | SetText (const wxString &text)
| Sets the text for this UI element.
void | Show (bool show)
| Show or hide the UI element.
## Static Public Member Functions
static bool | CanUpdate (wxWindow *window)
| Returns true if it is appropriate to update (send UI update events to) this window.
static wxUpdateUIMode | GetMode ()
| Static function returning a value specifying how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.
static long | GetUpdateInterval ()
| Returns the current interval between updates in milliseconds.
static void | ResetUpdateTime ()
| Used internally to reset the last-updated time to the current time.
static void | SetMode (wxUpdateUIMode mode)
| Specify how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.
static void | SetUpdateInterval (long updateInterval)
| Sets the interval between updates in milliseconds.

List of all members.

## Constructor & Destructor Documentation

wxUpdateUIEvent::wxUpdateUIEvent | ( | wxWindowID | commandId = `0` | ) |

Constructor.

## Member Function Documentation

static bool wxUpdateUIEvent::CanUpdate | ( | wxWindow * | window | ) | `[static]`

Returns true if it is appropriate to update (send UI update events to) this window.

This function looks at the mode used (see wxUpdateUIEvent::SetMode), the wxWS_EX_PROCESS_UI_UPDATES flag in window, the time update events were last sent in idle time, and the update interval, to determine whether events should be sent to this window now. By default this will always return true because the update mode is initially wxUPDATE_UI_PROCESS_ALL and the interval is set to 0; so update events will be sent as often as possible. You can reduce the frequency that events are sent by changing the mode and/or setting an update interval.

See also:
  ResetUpdateTime(), SetUpdateInterval(), SetMode()

void wxUpdateUIEvent::Check | ( | bool | check | ) |

Check or uncheck the UI element.

void wxUpdateUIEvent::Enable | ( | bool | enable | ) |

Enable or disable the UI element.

bool wxUpdateUIEvent::GetChecked | ( |  | ) | const

Returns true if the UI element should be checked.

bool wxUpdateUIEvent::GetEnabled | ( |  | ) | const

Returns true if the UI element should be enabled.

static wxUpdateUIMode wxUpdateUIEvent::GetMode | ( |  | ) | `[static]`

Static function returning a value specifying how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.

See also:
  SetMode()

bool wxUpdateUIEvent::GetSetChecked | ( |  | ) | const

Returns true if the application has called Check().

For wxWidgets internal use only.

bool wxUpdateUIEvent::GetSetEnabled | ( |  | ) | const

Returns true if the application has called Enable().

For wxWidgets internal use only.

bool wxUpdateUIEvent::GetSetShown | ( |  | ) | const

Returns true if the application has called Show().

For wxWidgets internal use only.

bool wxUpdateUIEvent::GetSetText | ( |  | ) | const

Returns true if the application has called SetText().

For wxWidgets internal use only.

bool wxUpdateUIEvent::GetShown | ( |  | ) | const

Returns true if the UI element should be shown.

wxString wxUpdateUIEvent::GetText | ( |  | ) | const

Returns the text that should be set for the UI element.

static long wxUpdateUIEvent::GetUpdateInterval | ( |  | ) | `[static]`

Returns the current interval between updates in milliseconds.

The value -1 disables updates, 0 updates as frequently as possible.

See also:
  SetUpdateInterval().

static void wxUpdateUIEvent::ResetUpdateTime | ( |  | ) | `[static]`

Used internally to reset the last-updated time to the current time.

It is assumed that update events are normally sent in idle time, so this is called at the end of idle processing.

See also:
  CanUpdate(), SetUpdateInterval(), SetMode()

static void wxUpdateUIEvent::SetMode | ( | wxUpdateUIMode | mode | ) | `[static]`

Specify how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.

Parameters:

  | mode | this parameter may be one of the wxUpdateUIMode enumeration values. The default mode is wxUPDATE_UI_PROCESS_ALL.

void wxUpdateUIEvent::SetText | ( | const wxString & | text | ) |

Sets the text for this UI element.

static void wxUpdateUIEvent::SetUpdateInterval | ( | long | updateInterval | ) | `[static]`

Sets the interval between updates in milliseconds.

Set to -1 to disable updates, or to 0 to update as frequently as possible. The default is 0.

Use this to reduce the overhead of UI update events if your application has a lot of windows. If you set the value to -1 or greater than 0, you may also need to call wxWindow::UpdateWindowUI at appropriate points in your application, such as when a dialog is about to be shown.

void wxUpdateUIEvent::Show | ( | bool | show | ) |

Show or hide the UI element.

|  | [ top ]